#
# This is the SPEC file for creating binary RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, see <https://www.gnu.org/licenses/>.
#
#

Name:		qubes-core-qrexec-vm
Version:	4.2.15
Release:	1%{dist}
Summary:	The Qubes qrexec files (qube side)

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

BuildRequires:	gcc
BuildRequires:	pam-devel
BuildRequires:	pandoc
BuildRequires:	qubes-libvchan-devel
BuildRequires:	qubes-core-qrexec-devel
BuildRequires:	lsb-core-noarch
BuildRequires:	systemd-devel

Requires:   python%{python3_pkgversion}
Requires:   qubes-core-qrexec = %{version}-%{release}

Provides:   qubes-core-agent-qrexec = 4.1.0-1
Obsoletes:  qubes-core-agent-qrexec < 4.1.0-1

Source0: qubes-core-qrexec-%{version}.tar.gz

Requires: (%{name}-selinux if selinux-policy)

%package selinux
BuildRequires: selinux-policy
BuildRequires: selinux-policy-devel
%{?selinux_requires}
Requires(post): qubes-core-agent-selinux
Summary: SELinux policies for qrexec
License: GPLv2+

%description selinux
The SELinux policies for qrexec.  You need this package if you want to have
SELinux enforcing in a qube.

%description
The Qubes qrexec files for installation on a qube.

%prep
%setup -qn qubes-core-qrexec-%{version}

%build
%{?set_build_flags}
make all-vm all-vm-selinux
#make -C doc PYTHON=%{__python3} SPHINXBUILD=sphinx-build-%{python3_version} man

%install
make install-vm install-vm-selinux \
    DESTDIR=$RPM_BUILD_ROOT \
    UNITDIR=%{_unitdir} \
    PYTHON_SITEPATH=%{python3_sitelib} \
    SYSCONFDIR=%{_sysconfdir}

#make -C doc DESTDIR=$RPM_BUILD_ROOT \
#    PYTHON=%{__python3} SPHINXBUILD=sphinx-build-%{python3_version} \
#    install

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%post
%systemd_post qubes-qrexec-agent.service

%preun
%systemd_preun qubes-qrexec-agent.service

%post selinux
%selinux_modules_install %{_datadir}/selinux/packages/qubes-core-qrexec.pp || :

%postun selinux
if [ "$1" -eq 0 ]; then
    %selinux_modules_uninstall %{_datadir}/selinux/packages/qubes-core-qrexec.pp
fi || :

%posttrans selinux
%selinux_relabel_post
exit 0

%posttrans
# when upgrading from R4.0, %%postun of qubes-core-agent-qrexec will revert
# %%post of this package. Redo the action in %%posttrans
%systemd_post qubes-qrexec-agent.service
# and then start it back
if systemctl is-enabled qubes-qrexec-agent.service >/dev/null 2>&1; then
    systemctl start qubes-qrexec-agent.service
fi

%files
%defattr(-,root,root,-)
%config(noreplace) /etc/pam.d/qrexec
%dir /etc/qubes/rpc-config
/etc/qubes/rpc-config/README

%{_bindir}/qrexec-client-vm
%{_bindir}/qrexec-fork-server

%{_mandir}/man1/qrexec-client-vm.1*

/usr/lib/qubes/qrexec-agent
/usr/lib/qubes/qrexec-client-vm
/usr/lib/qubes/qrexec_client_vm
/lib/systemd/system/qubes-qrexec-agent.service

%files selinux
%{_datadir}/selinux/devel/include/contrib/ipp-qubes-core-qrexec.if
%{_datadir}/selinux/packages/qubes-core-qrexec.pp

%changelog
* Sun Oct 22 2023 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-core-qrexec.git

* Sun Oct 22 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 0c5d8bc
- version 4.2.15

* Sun Oct 22 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a9f9c2b
- ci: fixup coverage data collection

* Fri Oct 20 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 5ba4a8d
- Don't wait for stdin if there is unsent prefix data

* Fri Oct 20 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e1553db
- ci: upload gcov coverage data too

* Thu Oct 12 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d0cbbfb
- version 4.2.14

* Thu Oct 12 2023 Marta Marczykowska-Górecka <marmarta@invisiblethingslab.com> - 654e3e0
- Fix conversion rules for input policy

* Tue Oct 10 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 96dbbf7
- version 4.2.13

* Tue Oct 10 2023 Marta Marczykowska-Górecka <marmarta@invisiblethingslab.com> - 2849c90
- Tests for legacy policy convert tool

* Tue Oct 10 2023 Marta Marczykowska-Górecka <marmarta@invisiblethingslab.com> - 8988142
- Modify qrexec-policy-graph for more flexibility

* Fri Oct 06 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 28c1504
- Adjust pylint config

* Fri Oct 06 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 51c6309
- version 4.2.12

* Mon Sep 25 2023 Marta Marczykowska-Górecka <marmarta@invisiblethingslab.com> - b570f1f
- Add a tool to convert legacy policy files to new format

* Tue Sep 19 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 0fa8ecc
- Ensure that VLAs do not creep back into the code

* Tue Sep 19 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 0f51d6d
- Allow specifying a username in service config

* Mon Sep 18 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 02ff1aa
- Fix qrexec-policy-graph tool

* Fri Sep 15 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - a073c30
- Prepare for parsing username from service config

* Fri Sep 15 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 174a501
- qrexec-fork-server: validate data from qrexec-agent

* Fri Sep 15 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 32719f2
- Use _exit(), not exit(), in child process after fork

* Fri Sep 15 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 955c3ec
- Add a missing printf attribute

* Sat Sep 09 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5f68a98
- version 4.2.11

* Thu Sep 07 2023 Frédéric Pierret (fepitre) <frederic@invisiblethingslab.com> - 776f694
- Support for Fedora 39

* Sat Sep 02 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2c060ef
- version 4.2.10

* Sat Sep 02 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8cf1a6b
- Add connection timeout on the VM side too

* Sun Aug 27 2023 Ben Grande <ben.grande.b@gmail.com> - 42c8574
- Add lint and editor policy tools

* Sat Aug 26 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 79609b1
- version 4.2.9

* Sat Aug 19 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 697084f
- policy/admin: fix handling missing 'qubes' group

* Sat Aug 19 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9fdf915
- Fix issues in qrexec-policy-agent found by pylint

* Sat Aug 19 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3407618
- cleanup pylintrc

* Sat Aug 19 2023 Ben Grande <ben.grande.b@gmail.com> - 2562621
- parser: Change warning of invalid path to error

* Sat Aug 19 2023 Ben Grande <ben.grande.b@gmail.com> - da87fb1
- Fix policy.Replace changing mode and owners

* Fri Jul 21 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 403eaa2
- version 4.2.8

* Sat Jul 08 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 349e42c
- Make policy.RegisterArgument use new policy format

* Sun Jul 02 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 10adc83
- version 4.2.7

* Fri Jun 30 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - fdcbfd7
- Reject service names that start with +

* Fri Jun 30 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 6cb897a
- Reject interior NUL bytes in service name

* Fri May 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 4ca6be1
- Move variables into MSG_TRIGGER_SERVICE3 block

* Fri May 26 2023 Ben Grande <ben.grande.b@gmail.com> - 587fa68
- Fix python3-qrexec missing on qubes-core-qrexec

* Fri May 26 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 87ea44e
- daemon: fix memory leak

* Fri May 26 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d667dec
- daemon: add missing brackets in validate_request_id

* Wed May 24 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 5eefd4e
- Ensure that all external variables are type-checked

* Wed May 24 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 6e18e38
- Banish old-style function declarations

* Tue May 23 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - c70709d
- Shut up pylint

* Tue May 23 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 07075e9
- Support Debian 11

* Fri May 19 2023 Ben Grande <ben.grande.b@gmail.com> - d0f4a16
- Fix missing include in RPC names in admin_client

* Thu May 18 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - fd1f249
- Fix header validation by qrexec agent

* Thu May 18 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a0121aa
- Revert "Use close_range(2) instead of manual close loop"

* Mon May 15 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9e70ff8
- fuzz: daemon->handle_message_from_agent()

* Mon May 15 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 84f9d18
- fuzz: fix generating seed corpus

* Mon May 15 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 249a64c
- fuzz: add mockup of libvchan_client_init()

* Mon May 15 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f9c8147
- daemon: prepare handle_message_from_agent() for fuzzing

